#!/usr/bin/env python	

# This script shows what the most popular referers to pages on your site are.
# (this requires CombinedWebLog)

import sys, CombinedWebLog, WebLogUrlParse, WebLogClean, WebLogReferType

o_log = CombinedWebLog.Parser(sys.stdin)
p_log = WebLogUrlParse.UrlParser(o_log)

c_log = WebLogClean.Cleaner(p_log)
c_log.directory_index = ['index.html', 'index.htm']

log = WebLogReferType.ReferTyper(c_log)
log.siteurl = ['www.foo.com', 'foo.com']

offsites = {}
while log.getlogent():
	if log.referer_type == 'OFFSITE':
		try:
			offsites[log.url][log.referer] = offsites[log.url].get(log.referer, 0) + 1
		except KeyError:
			offsites[log.url] = {}
			offsites[log.url][log.referer] = 1

pages = offsites.keys()
pages.sort()	
for page in pages:
	print "\n%s" % (page)
	ref_nums = offsites[page]
	referers = ref_nums.keys()
	referers.sort(lambda a, b, rn = ref_nums: cmp(rn[b], rn[a]))
	for referer in referers:
		print "%s  %s" % (ref_nums[referer], referer)
		
		
